/* 
	Author: UAB Euro Info
	Url: https://postit.lt
*/
$(function(){
	if(typeof postit_data !== 'object'){
		return;
	}
	if(typeof window.console === 'undefined') {
		window.console = {
			log: function (msg){},
			warn: function (msg){}
		};
	}
	
	var $address = $(postit_data.params.address);
	
	if($address.length !== 1){
		console.warn('postit.lt (PS 1.6) - Address input not found');
		return;
	}
	if(typeof $address.autocomplete !== 'function'){
		console.warn('postit.lt (PS 1.6) - Autocomplete is not function');
		return;
	}
	
	if(postit_data.params.is_trial){
		$(postit_data.params.postcode).after(postit_data.params.trial_text);
	}
	
	$address.autocomplete(postit_data.url, {
		minChars: 4,
		delay: 400,
		multiple: false,
		autoFill: false,
		selectFirst: false,
		scroll: false,
		dataType: 'json',
		extraParams: postit_data.args,
		formatItem: function(data, i, max, value, term) {
			return value;
		},
		parse: function(resp) {
			var r = [];
			if ( !resp.success ){
				console.warn(postit_data.url + ' - ' + resp.message);
				return r;
			}
			
			for( var i = 0, l = resp.data.length; i < l; i++ ){
				var t = '';
				var address = resp.data[i].address;
				var municipality = resp.data[i].municipality;

				if ( address === '' ){
					//Šis atvejis nutinka tada, kai ieškoma ne pagal adresą, o pagal pašto kodą arba vietovę
					if(resp.data[i].mailbox !== ''){
						//Pvz.: ieškant pagal "00002" ar "Pašto dėžutė 1"
						address = ('Post Box ' + resp.data[i].mailbox);
						t = (address + ', ' + resp.data[i].city);
					}
					else {
						//Pvz.: ieškant pagal "20100" ar "Bernotiškių k."
						t = (resp.data[i].city + ', ' + resp.data[i].municipality);
					}
				} else {
					t = (address + ', ' + resp.data[i].city);
				}
				
				r.push({
					data: {
						label: t,
						value: address,
						address: address,
						municipality: municipality,
						city: resp.data[i].city,
						post_code: resp.data[i].post_code
					},
					value: t + ', ' + postit_data.config.prefix + resp.data[i].post_code + postit_data.config.label_suffix,
					result: address
				});
			}

			return r;
		}
	})
	.result(function(event, data, formatted) {
		$(postit_data.params.postcode).val(postit_data.config.prefix + data.post_code);
		$(postit_data.params.city).val(data.city);
		$(postit_data.params.address).val(data.address);
		if(postit_data.params.municipality != ''){
			$(postit_data.params.municipality).val(data.municipality);
		}
	});
});
